
## Nom du fichier : installmseide5100.sh
## Télécharge, compile et installe MSEide 5.10.0 sous Linux.
## L'installation consiste dans la création de deux raccourcis : l'un sur le bureau, l'autre dans le menu des applications.

## Le script doit être placé à l'endroit où l'on souhaite que le dossier mseide5100 soit créé.
## Commande : sh installmseide5100.sh

## Au premier lancement de MSEide, vous devez aller dans Settings/Configure MSEide et sélectionnez le dossier mseide5100 pour la variable MSEDIR.

URL=https://github.com/mse-org/mseide-msegui/archive/refs/tags/5.10.0.zip
SCRIPT="$(realpath -s "$0")"
SCRIPTPATH="$(dirname "$SCRIPT")"
UNITS=$SCRIPTPATH/units
REVISION="5100"
## Base name for desktop files
BASENAME="mseide$REVISION"
## Application full name
APP="MSEide 5.10.0"
## Script directory
SCRDIR="$(dirname "$(readlink -f "$0")")"
## Desktop directory
DDIR="$HOME/Desktop"
## Applications menu directory
ADIR="$HOME/.local/share/applications"

echo "**** Téléchargement"

wget -O 5.10.0.zip $URL

echo "**** Décompression"

unzip 5.10.0.zip -d $SCRIPTPATH
## mseide-msegui-5.10.0

mv $SCRIPTPATH/mseide-msegui-5.10.0 $SCRIPTPATH/mseide5100

echo "**** Compilation de MSEide"

mkdir -p $UNITS

pushd $SCRIPTPATH/mseide5100/apps/ide/

fpc -omseide \
-Fu../../lib/common/* \
-Fu../../lib/common/kernel \
-Fi../../lib/common/kernel \
-Fu../../lib/common/kernel/linux \
-Fu../../lib/addon/* \
-Fi../../lib/addon/* \
-FU$UNITS \
-Xg -l -Mobjfpc -Sh -Fcutf8 -gl -O- mseide.pas

popd

echo "**** Création du fichier .desktop"

if [ ! -d $DDIR ] ;
then
  echo "** Dossier introuvable : $DDIR"
  DDIR="$HOME/Bureau"
fi

if [ -d $DDIR ] ;
then
  FILE=$DDIR/$BASENAME.desktop
  echo "** Création du fichier $FILE"
  cat > $FILE << EOF
[Desktop Entry]
Version=1.0
Type=Application
Name=$APP
Comment=Pascal IDE
Exec=$SCRDIR/$BASENAME/apps/ide/mseide --globstatfile=$SCRDIR/$BASENAME/apps/ide/mseide.sta %F
Icon=$SCRDIR/$BASENAME/msegui_64.png
Path=$SCRDIR/$BASENAME/apps/ide
Terminal=false
StartupNotify=true
EOF
  echo "** Permission d'exécuter"
  sudo chmod -R 777 $FILE
  echo "** Fait"
else
  echo "** Dossier introuvable : $DDIR"
  exit 0
fi

echo "**** Copie du fichier .desktop pour le menu des applications"

if [ -d $ADIR ] ;
then
  FILE=$DDIR/$BASENAME.desktop
  FILE2=$ADIR/$BASENAME.desktop
  echo "** Création du fichier $FILE2"
  cp -f $FILE $FILE2
  echo "** Permission d'exécuter"
  sudo chmod -R 777 $FILE2
  echo "** Fait"
else
  echo "** Dossier introuvable : $ADIR"
  exit 0
fi
